# This class connects to the local server (see Server class).  Messages sent to the local server are forwarded.  The server class handles messages
# received from the remote server.

require "socket"
module Apiotics
  class Client
    def initialize( server = 'localhost', port = Apiotics.configuration.local_port )
      @server = server
      @port = port
    end

    def send(msg)
      connection = TCPSocket.open(@server, @port)
      connection.puts( msg )
      connection.close
    end
    
  end

end