module Apiotics
  class ScaffoldGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :worker_name, :type => :string
    
    def create_scaffold
      @c = Apiotics::Portal.parse_all_interfaces
      generate "apiotics:initializer", "true"
      drivers = @c[worker_name].keys
      drivers.each do |driver|
        generate "apiotics:model", "#{worker_name} #{driver}"
      end
      generate "apiotics:controller", "#{worker_name}"
    end
  
    private

    def date_string
      date_string = DateTime.now.strftime("%Y%m%d%H%M%S")
    end    
    
  end
end