module Apiotics
  class Configuration
  
    attr_accessor :public_key, :private_key, :local_logging, :targets, :local_port, :server, :server_port, :portal, :push, :tls, :verify_peer, :handshake, :parents
  
    def initialize
      @public_key = nil
      @private_key = nil
      @local_logging = false
      @targets = nil
      @local_port = 8001
      @server = "rgs.microarx.com"
      @server_port = 8000
      @portal = "https://test.apiotics.com/"
      @push = false
      @tls = true
      @verify_peer = true
      @handshake = true
      @parents = {}
    end
  
  end
end