require 'apiotics'
require 'rails'

module Apiotics
  class Railtie < Rails::Railtie
    generators do
      require 'lib/generators/apiotics/model'
      require 'lib/generators/apiotics/create_table'
      require 'lib/generators/apiotics/create_model'
      require 'lib/generators/apiotics/initializer'
      require 'lib/generators/apiotics/migration'
    end
  end
end